%==========================================================================
% Replication codes for Bianchi-Nicolo' 
% "A Generalized Approach to Indeterminacy in Linear Rational Expectations Models"
% Quantitative Economics
%==========================================================================
function [ tt ] = dsge_imprf_plot_bands( irf_p_y,vnames,shnames,regnames,figname,thr,hl,rain )
ninput=nargin;
nsh=size(irf_p_y,3);nvar=size(irf_p_y,2);
tt=1:1:size(irf_p_y,1);
f = figure;
if ninput<=7

    rain=char('b','r','b-.','r-.');

    
end


for is=1:nsh
    for iv=1:nvar
        subplot(nsh,nvar,(is-1)*nvar+iv);

        plot(tt,squeeze(irf_p_y(:,iv,is,1)),...
            tt,squeeze(irf_p_y(:,iv,is,2)),'r--',...
            tt,squeeze(irf_p_y(:,iv,is,3)),'r--');
        hold on


        
        if ninput>1
            if size(vnames,1)>0
                if iv==1 && size(shnames,1)>0
                    if size(shnames,1)==1
                    ylabel(shnames(:,is),'interpreter','latex')    
                    else
                    ylabel(shnames(is,:),'interpreter','latex')
                    end
                end
                if is==1
                    if size(vnames,1)==1
                    title(vnames{iv})    
                    else
                    title(vnames(iv,:))
                    end
                end
            end
            if ninput>=6
                if size(thr,1)>0
                    vline(thr)
                end
                if ninput>=7
                    if  isempty(hl)~=1
                    hline(hl(iv))
                    end
                end
            end
        end
        axis tight
    end
end
if ninput>3
    if size(regnames,1)>0
        legend(regnames,'Location','Best')
    end
    if ninput>4
        if size(figname,1)>0
            set(f,'name',figname,'numbertitle','off')
        end
    end
end

end

