%==========================================================================
% Replication codes for Bianchi-Nicolo' 
% "A Generalized Approach to Indeterminacy in Linear Rational Expectations Models"
% Quantitative Economics
%==========================================================================
function [prvec]=from_prsum_to_prvec(PRSUM,SUBV,varargin)

if nargin<=2 
    basic=1;
else
    msel=varargin{1};
    if sum(msel(26)==[0,1,2,3,22,21])
        if msel(26)==1 || msel(26)==0
        basic=1;
        elseif msel(26)==2 || msel(26)==22 || msel(26)==21
        basic=2;    
        elseif msel(26)==3 
        basic=3;    
        end
    else
        basic=0;
    end
end
if basic==1 
    nsb=size(PRSUM{1},3);
    nsc=size(PRSUM{3},3);
    % keyboard
    % Structural parameters
    prvec=PRSUM{1}(SUBV{1},:,1) ; % MS Str para
    for ib=2:nsb
        prvec=[prvec; PRSUM{1}(SUBV{1},:,ib)]; %MS st para
    end
    prvec=[prvec; PRSUM{1}(SUBV{2},:,1)]; %FC st para

    % Other strucutral parameters
    prvec=[prvec; PRSUM{2}(SUBV{5},:)]; %FC ss para

    % Structural errors
    for ic=1:nsc
        prvec=[prvec; PRSUM{3}(SUBV{7},:,ic)]; %MS st errors
    end
    prvec=[prvec;PRSUM{3}(SUBV{8},1:3,1)]; % FC Str errors

    % Observation errors
    prvec=[prvec;PRSUM{4}(SUBV{11},:) ];% obs error
%     keyboard
elseif basic==2 
    nsb=size(PRSUM{1},3);
    nsc=size(PRSUM{3},3);
    % keyboard
    % Structural parameters
    prvec=PRSUM{1}(SUBV{1},:,1) ; % MS Str para
    if msel(26)==2 ||  msel(26)==21
        for ib=2:nsb
            prvec=[prvec; PRSUM{1}(SUBV{1},:,ib)]; %MS st para
        end
    elseif msel(26)==22
        for ib=2:nsb/2
            prvec=[prvec; PRSUM{1}(SUBV{1},:,ib)]; %MS st para
        end    
    end
    prvec=[prvec; PRSUM{1}(SUBV{2},:,1)]; %FC st para

    % Other strucutral parameters
    prvec=[prvec; PRSUM{2}(SUBV{5},:)]; %FC ss para

    % Structural errors
    nchains_sv=size(SUBV{7},1);
    for ic=1:nthroot(nsc,nchains_sv) % Two separate chains
        prvec=[prvec; PRSUM{3}(SUBV{7},:,ic)]; %MS st errors
    end
    prvec=[prvec;PRSUM{3}(SUBV{8},:,1)]; % FC Str errors

    % Observation errors
    prvec=[prvec;PRSUM{4}(SUBV{11},:) ];% obs error
elseif basic==3 
    nsb=size(PRSUM{1},3);
    nsc=size(PRSUM{3},3);
    % keyboard
    % Structural parameters
    prvec=PRSUM{1}(SUBV{1},:,1) ; % MS Str para
    prvec=[prvec; PRSUM{1}(SUBV{1},:,2)]; %MS st para
    
%     for ib=2:nsb
%         prvec=[prvec; PRSUM{1}(SUBV{1},:,ib)]; %MS st para
%     end
    prvec=[prvec; PRSUM{1}(SUBV{2},:,1)]; %FC st para

    % Other strucutral parameters
    prvec=[prvec; PRSUM{2}(SUBV{5},:)]; %FC ss para

    % Structural errors
    for ic=1:nsc
        prvec=[prvec; PRSUM{3}(SUBV{7},:,ic)]; %MS st errors
    end
    prvec=[prvec;PRSUM{3}(SUBV{8},:)]; % FC Str errors

    % Observation errors
    prvec=[prvec;PRSUM{4}(SUBV{11},:) ];% obs error
    
    
   
else
    msel=varargin{1};
    nunu = num2str(msel(26)) ;
    fcpara=strcat('from_prsum_to_prvec_',nunu);
    [prvec]=feval(fcpara,PRSUM,SUBV);

end
end



