%==========================================================================
% Replication codes for Bianchi-Nicolo' 
% "A Generalized Approach to Indeterminacy in Linear Rational Expectations Models"
% Quantitative Economics
%==========================================================================
function [trvec]=from_trspec_to_trvec2(TRSPEC,SUBV,nsb,nsc,msel)


if sum(msel(26)==[0,1,2,3,4,22,21])
    % Structural parameters
    if msel(26)~=22 && msel(26)~=3
    trvec=repmat(TRSPEC{1}(SUBV{1},:),nsb,1) ; % MS Str para
    else
    trvec=repmat(TRSPEC{1}(SUBV{1},:),nsb/2,1) ; % MS Str para
    end
    trvec=[trvec; TRSPEC{1}(SUBV{2},:,1)]; %FC st para

    % Other strucutral parameters
    trvec=[trvec; TRSPEC{2}(SUBV{5},:)]; %FC ss para

    % Structural errors
    if msel(26)~=2 && msel(26)~=22 && msel(26)~=21
    trvec=[trvec; repmat(TRSPEC{3}(SUBV{7},:),nsc,1)]; % MS str errors
    else
        nchains_sv=size(SUBV{7},1);

        trvec=[trvec; repmat(TRSPEC{3}(SUBV{7},:),nthroot(nsc,nchains_sv),1)]; % MS str errors    
    end
    trvec=[trvec;TRSPEC{3}(SUBV{8},:)]; % FC Str errors

    % Observation errors
    trvec=[trvec;TRSPEC{4}(SUBV{11},:) ];% obs error
else
    nunu = num2str(msel(26)) ;
    fcpara=strcat('from_trspec_to_trvec_',nunu);
    [trvec]=feval(fcpara,TRSPEC,SUBV,nsb,nsc);
end
end



