%==========================================================================
% Replication codes for Bianchi-Nicolo' 
% "A Generalized Approach to Indeterminacy in Linear Rational Expectations Models"
% Quantitative Economics
%==========================================================================
function prsum=priors_oe_1002(msel)

% pshape: 0 is point mass, both para and pstdd are ignored
%         1 is BETA(mean,stdd)
%         2 is GAMMA(mean,stdd)
%         3 is NORMAL(mean,stdd)
%         4 is INVGAMMA(s^2,nu)

% Corr sunspot 2 - 1
%[1]r_suns2_1 
pmean(1,:)=-1;
pstdd(1,:)=1;
pshape(1,:)=6;

%[2]sigmp - Here we define s and nu for inverse gamma 
me=0.1/100;
sd=0.3/100;
[s,nu]=inverse_gamma_specification(me,sd,1);
pmean(2,:)=s;
pstdd(2,:)=nu;
pshape(2,:)=4;

%[3]sigmr - Here we define s and nu for inverse gamma           
me=0.05/100;
sd=0.3/100;
[s,nu]=inverse_gamma_specification(me,sd,1);
pmean(3,:)=s;
pstdd(3,:)=nu;
pshape(3,:)=4;

prsum=[pmean,pstdd,pshape];
