%==========================================================================
% Replication codes for Bianchi-Nicolo' 
% "A Generalized Approach to Indeterminacy in Linear Rational Expectations Models"
% Quantitative Economics
%==========================================================================
function prsum=priors_sp_1002(msel)

% pshape: 0 is point mass, both para and pstdd are ignored
%         1 is BETA(mean,stdd)
%         2 is GAMMA(mean,stdd)
%         3 is NORMAL(mean,stdd)
%         4 is INVGAMMA(s^2,nu)

%[1]rho            
pmean(1,:)=0.2;
pstdd(1,:)=0.1;
pshape(1,:)=2;

%[2]flb_adj        
pmean(2,:)=0.04;
pstdd(2,:)=0.01;
pshape(2,:)=2;

%[3]surp_adj         
pmean(3,:)=0.4;
pstdd(3,:)=0.1;
pshape(3,:)=2;

%[4]kap
pmean(4,:)=0.04;
pstdd(4,:)=0.005;
pshape(4,:)=2;

%[5]psipi
pmean(5,:)= 1;
pstdd(5,:)=0.4;
pshape(5,:)=2;

%[6]psiq
pmean(6,:)=0.05;
pstdd(6,:)=0.02;
pshape(6,:)=2;

%[7]rhoR
pmean(7,:)= 0.5;
pstdd(7,:)= 0.2;
pshape(7,:)=1;

%[8]rhoq
pmean(8,:)=0.7;
pstdd(8,:)=0.1;
pshape(8,:)=1;

%[9]rhos
pmean(9,:)=0.7;
pstdd(9,:)=0.1;
pshape(9,:)=1;

%[10]alph1
pmean(10,:)=0;
pstdd(10,:)=2;
pshape(10,:)=6;

%[11]alph2
pmean(11,:)=0;
pstdd(11,:)=2;
pshape(11,:)=6;

prsum=[pmean,pstdd,pshape];
