%==========================================================================
% Replication codes for Bianchi-Nicolo' 
% "A Generalized Approach to Indeterminacy in Linear Rational Expectations Models"
% Quantitative Economics
%==========================================================================
clear para 
clear subvsp_ms subvsp_fc subvsp_fx
clear subvss_ms subvss_fc subvss_fx
clear subvse_ms subvse_fc subvse_fx
clear subvoe_fc subvoe_fx subvoe_fx;


ii=1;
%[1]rho
para(ii,:) =  [3,  0.2];ii=ii+1; % Calibrated to ensure identification
%[2]flb_adj
para(ii,:) =  [2, -inf];ii=ii+1;
%[3]surp_adj                  
para(ii,:) =  [3,  0.4];ii=ii+1;
%[4]kappa                
para(ii,:) =  [2, -inf];ii=ii+1;
%[5]psi_pi                
para(ii,:) =  [1, -inf];ii=ii+1;
%[6]psi_q            
para(ii,:) =  [1, -inf];ii=ii+1;
%[7]rhoR                    
para(ii,:) =  [1, -inf];ii=ii+1;
%[8]rhoq
para(ii,:) =  [2, -inf];ii=ii+1;
%[9]rhos                  
para(ii,:) =  [2, -inf];ii=ii+1;
%[10]alph1
para(ii,:) =  [3, 1.5];ii=ii+1;
%[11]alph2                
para(ii,:) =  [3, 1.5];ii=ii+1;

[subvsp_ms]=find(para(:,1)==1);
[subvsp_fc]=find(para(:,1)==2);
[subvsp_fx(:,1)]=find(para(:,1)==3);
[subvsp_fx(:,2)]=para(subvsp_fx(:,1),2);

clear para
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% STEADY STATES

ii=1;
%[12]log(pdt)
para(ii,:) =  [2, -inf];ii=ii+1;
%[13]fub
para(ii,:) =  [3,0.925];ii=ii+1;
%[14]log(pi_st)
para(ii,:) =  [2, -inf];ii=ii+1;

[subvss_ms]=find(para(:,1)==1);
[subvss_fc]=find(para(:,1)==2);
[subvss_fx(:,1)]=find(para(:,1)==3);
[subvss_fx(:,2)]=para(subvss_fx(:,1),2);

clear para
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% STRUCTURAL ERRORS
ii=1;
%[15]sigR - Here we actually define s and nu for inverse gamma
para(ii,:) =  [1, -inf];ii=ii+1;
%[16]sigq 
para(ii,:) =  [1, -inf];ii=ii+1;
%[17]sigs 
para(ii,:) =  [1, -inf];ii=ii+1;
%[18]sigsuns1         
para(ii,:) =  [2, -inf];ii=ii+1;
%[19]sigsuns2
para(ii,:) =  [2, -inf];ii=ii+1;
%[20]r_suns1_R           
para(ii,:) =  [2, -inf];ii=ii+1;
%[21]r_suns1_q           
para(ii,:) =  [2, -inf];ii=ii+1;
%[22]r_suns1_R     
para(ii,:) =  [2, -inf];ii=ii+1;
%[23]r_suns2_R           
para(ii,:) =  [2, -inf];ii=ii+1;
%[24]r_suns2_q           
para(ii,:) =  [2, -inf];ii=ii+1;
%[25]r_suns2_R     
para(ii,:) =  [2, -inf];ii=ii+1;

[subvse_ms]=find(para(:,1)==1);
[subvse_fc]=find(para(:,1)==2);
[subvse_fx(:,1)]=find(para(:,1)==3);
[subvse_fx(:,2)]=para(subvse_fx(:,1),2);

clear para
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% OTHER PARAMETERS
ii=1;
%[19]r_suns2_1   
para(ii,:) =  [2, -inf];ii=ii+1;
%[20]sigmp - Here we actually define s and nu for inverse gamma 
para(ii,:) =  [3, 0];ii=ii+1;
%[21]sigmr - Here we actually define s and nu for inverse gamma           
para(ii,:) =  [3, 0];ii=ii+1;

[subvoe_ms]=find(para(:,1)==1);
[subvoe_fc]=find(para(:,1)==2);
[subvoe_fx(:,1)]=find(para(:,1)==3);
[subvoe_fx(:,2)]=para(subvoe_fx(:,1),2);

clear para



SUBV{1}=subvsp_ms;SUBV{2}=subvsp_fc;SUBV{3}=subvsp_fx;
SUBV{4}=subvss_ms;SUBV{5}=subvss_fc;SUBV{6}=subvss_fx;
SUBV{7}=subvse_ms;SUBV{8}=subvse_fc;SUBV{9}=subvse_fx;
SUBV{10}=subvoe_ms;SUBV{11}=subvoe_fc;SUBV{12}=subvoe_fx;
