%==========================================================================
% Replication codes for Bianchi-Nicolo' 
% "A Generalized Approach to Indeterminacy in Linear Rational Expectations Models"
% Quantitative Economics
%==========================================================================

function [T1,T0,RC,TETA,snames] = bini_dsgesolve3_fc2(p_st,p_ss,msel,varargin)
TETA=[];
snames=[];


h=size(p_st,2); % number of regimes
if size(varargin{1},1)>0
    SUBV1_phi_pi=varargin{1}(1);
    gridincr=varargin{1}(2);
end
if msel(6)==10 
 
else
    nunu = num2str(msel(6)) ;
    fcn=strcat('gammas_',nunu); 
end

    T1temp=cell(1,h);
    T0temp=cell(1,h);
    TETAtemp=cell(1,h);
    RC=nan(2,h);
    for ij = 1:h

        [GAM0,GAM1,PSI,PI,snames] = feval(fcn,p_st(:,ij),p_ss,msel);
        nS=size(GAM0,1);
        C=zeros(nS,1);
        TETAtemp{ij}=zeros(nS,1);
        [T1t,~,T0t,~,~,~,~,RCt,loose]=gensys(GAM0,GAM1,C,PSI,PI);
        if RCt(1)==1 && RCt(2)==0 && sum(msel(5)==[1,5]) % Construct solution under indet 
            if msel(5)==1 % Construct solution under indet using LS
                RCt2=RCt;regind=ij;
                if msel(6)~=10
                    % Construct grid for determinacy
                    nunudet = num2str(msel(6)) ;
                    fcndet=strcat('det_',nunudet);
                    eval(fcndet)
                end
   
                [T1t,~,T0i,~,~,~,TETAi]=gensys_f(GAM0,GAM1,C,PSI,PI);
                if size(TETAi,2)==1
                    p_st_star=p_st(:,ij);
                    if msel(6)~=10
                        aa=max(p_st_star(SUBV1_phi_pi,:),startingvalue);
                    else
                        aa=0;gridincr=.1;
                    end
                    while RCt2(2)~=1 && aa<=10 % Indeterminacy
                        div=1+10^-6;
                        if msel(6)==10
                            kap        = p_st(2);
                            psiy       = p_st(4);
                            rr_st      = p_ss(1);
                            bet = 1/(1+rr_st/400);
                            p_st_star(3,:) = 1 - bet*psiy*(1/bet-1)/kap+1E-4;
                        else
                            p_st_star(SUBV1_phi_pi,:)=aa;
                        end
                        [GAM0star,GAM1star,PSIstar,PIstar] = feval(fcn,p_st_star,p_ss,msel);

                        [~,~,T0stardet,~,~,~,~,~,RCt2]=gensys_f(GAM0star,GAM1star,C,PSIstar,PIstar,div);
                        aa=aa+gridincr;
                    end

                    if aa<=10
                        METAi = ((TETAi'*TETAi).^(-1))*TETAi'*(T0stardet-T0i);
                        T0t = T0i + TETAi*METAi;
                        TETAtemp{ij}=TETAi;
                    else
                        RCt=[-4;-4];%Could not find determinate solution
                    end
                    
                else
                    keyboard
                    RCt=[-3;-3];%More than one degree of indeterminacy
                end
            elseif msel(5)==5 % Construct solution under indet using BiNi
                fcn=strcat('flip_alpha_',nunu);
            end
  
        end
        T1temp{ij}=T1t;T0temp{ij}=T0t;RC(:,ij)=RCt; 
        clear T0t
    %     
    end
    
    [nS,nsh]=size(T0temp{1});
    if msel(5)~=1%No indeterminacy      
        T1=nan(nS,nS,h);
        T0=nan(nS,nsh,h);
        for ij=1:h
            T1(:,:,ij)=T1temp{ij};
            T0(:,:,ij)=T0temp{ij};
        end
    elseif msel(5)==1
        T1=nan(nS,nS,h);
        T0=nan(nS,nsh+1,h);
        for ij=1:h
            T1(:,:,ij)=T1temp{ij};
            T0(:,:,ij)=[T0temp{ij},TETAtemp{ij}];
        end
    end

end

