%==========================================================================
% Replication codes for Bianchi-Nicolo' 
% "A Generalized Approach to Indeterminacy in Linear Rational Expectations Models"
% Quantitative Economics
%==========================================================================
function [rloglh,sp,MAT,flag,ldet]=bini_fclike_ts3(yt,p_st,p_ss,p_er,o_er,HC,HB,msel,MAT,varargin)


loglhzero = -1E9*5;
ldet = [];
nsb=msel(10);
nsc=msel(11);


[T,Q,R,H,D,Z,~,RC,C,~,MAT]=bini_sysmat3_fc3(p_st,p_ss,p_er,o_er,HB,msel,MAT);



% **********************************************************
% ** Check determinacy 
% **********************************************************/
if RC(1)==1
    % A solution exists
    rcode(1) = 1;
    flag = 0; 
    if RC(2)==2 && msel(5)==2
        rcode(2) = 0;dddddddd
    elseif RC(2)==0 && msel(5)==2
        if msel(13)==1 || msel(13)==3 || msel(13)==35 % Only determinacy with gensys
           rcode = 0;flag=1;
        else
           rcode = 1;flag=0;
        end
    elseif RC(2)==1 && msel(5)==1 % Solution is determinate, but we want indeterminacy
        rcode = 0;flag=1;
    else
        % Unique solution
        rcode = 1;flag=0;
    end
%     
elseif RC(1)==-3 % Q matrix not semid pos
    rcode = -3.3300e+09;flag=2;
else
    % No solution
    rcode(1) = 0;
    rloglh = loglhzero;
    sp=0;
    flag=-1;
    MAT=[];

end

if msel(31)~=3 % Evaluate likelihood (No just checking existence of solution)
    if rcode(1)==1 
        if (nsc==1 && nsb==1) 
            [ rloglh,flag,~,~,~,~,ldet ] = eval_like_fc5( yt,D,Z,T,R,Q,H,msel );
            sp=0;
        else

        end


    else
        rloglh = -1E9*2;
        sp=0;
        MAT=[];
    end
else
    rloglh = rcode;
    sp=[];
    
    
end
