%==========================================================================
% Replication codes for Bianchi-Nicolo' 
% "A Generalized Approach to Indeterminacy in Linear Rational Expectations Models"
% Quantitative Economics
%==========================================================================
function [nlpo,sp,rloglh,lnprior,MAT,prdet,lidet,flag]=bini_neglpost(param,yt,prsum,msel,TRSPEC,HC,HB,SUBV)
prdet=cell(1,5);lidet=[];flag=0;


subvsp_ms=SUBV{1};subvsp_fc=SUBV{2};%subvsp_fx=SUBV{3};
subvss_ms=SUBV{4};subvss_fc=SUBV{5};subvss_fx=SUBV{6};
subvse_ms=SUBV{7};subvse_fc=SUBV{8};subvse_fx=SUBV{9};
subvoe_ms=SUBV{10};subvoe_fc=SUBV{11};subvoe_fx=SUBV{12};

MAT=SUBV{16};


p_st=param{1};p_ss=param{2};p_er=param{3};o_er=param{4};HBE=param{5};
abcd=param{6};EXTRA=param{7};

nsb2=size(p_st,2); 
nsc2=size(p_er,2); 

if size(TRSPEC,2)>=10
    ck2=0;ck3=0;ck4=0;
    lb=TRSPEC{10}(:,2);
    ub=TRSPEC{10}(:,3);
    ck1=any(abcd>ub) || any(abcd<lb);
else
end



ck5=sum(any(HB<0)) || sum(any(HB>1)) || abs(sum(sum(HB))-size(HB,1))>10^-10;
ck6=sum(any(HC<0)) || sum(any(HC>1)) || abs(sum(sum(HC))-size(HC,1))>10^-10;
ck7=sum(any(HBE<0)) || sum(any(HBE>1)) || abs(sum(sum(HBE))-size(HBE,1))>10^-10;


ck=ck1+ck2+ck3+ck4+ck5+ck6+ck7;


if size(SUBV{18},1)>0
    invar=SUBV{18}(:,end);
    ID = normalization( p_st(invar,:),SUBV{18}(:,1:nsb2));
else
    ID=1;
end

nsb=msel(10);
if ck==0 && ID==1

         
        if sum(msel(31)==[0,2,3]) % Max prior, post, or check sol exists
            if msel(25)==-2 
            elseif msel(25)==-5 
            else 
                
                [rloglh,sp,MAT,flag,lidet]=bini_fclike_ts3(yt,p_st,p_ss,p_er,o_er,HC,HB,msel,MAT);    
                
                
            end
        else
            rloglh=0;sp=[];
        end
       
        if msel(31)==1 || msel(31)==0 % Max prior or posterior
            
            [lnprior,prdet{1}] = priodens2(abcd,prsum{10}); 

           
        else
            lnprior=0;
        end

        nlpo=-real(lnprior+rloglh);
        
        

else
    nlpo=3*10^13;
    lnprior=-3*10^13;
    rloglh=-3*10^13;
    sp=0;
    MAT=[];
    flag=2; % Outside boundaries
end