%==========================================================================
% Replication codes for Bianchi-Nicolo' 
% "A Generalized Approach to Indeterminacy in Linear Rational Expectations Models"
% Quantitative Economics
%==========================================================================
function pan=bini_proposec3(pao,iH,BOU,ccs,varargin)

% Proposal for the parameters
% pao:     parameters from previous iteration
% iH05:    inverse hessian at posterior mode (square root for normal)
% bounds:  bounds for the parameters
if nargin>4
    shape = varargin{1};
end
if nargin==4 || shape==0
    ck=1;
    while ck==1
        pan=mvnrnd(pao,ccs*iH,1)';
        ck=any(pan>BOU(:,2)) || any(pan<BOU(:,1));

    end
else
    dist = varargin{1};
    if dist==1 % t-student distribution
   
    elseif dist==2 % Mixture of normals
        prop = varargin{2}(1); % Probability draw from large variance
        rescale = varargin{2}(2);
        sp=size(pao,1);
        ck=1;
        while ck==1
            if rand<prop
                pan=mvnrnd(pao,rescale*ccs*iH,1)';
            else
                pan=mvnrnd(pao,ccs*iH,1)';
            end
            
            ck=any(pan>BOU(:,2)) || any(pan<BOU(:,1));

        end
    end

end
        
