%==========================================================================
% Replication codes for Bianchi-Nicolo' 
% "A Generalized Approach to Indeterminacy in Linear Rational Expectations Models"
% Quantitative Economics
%==========================================================================
function [p_st,p_ss,p_er,o_er,HB,HC,HBE,EXTRA]=bini_vpara_to_para6(z1,z2,z3,z4,z5,z6,z7,SUBV,msel)
% z1: parameters that are free to move
% z2 & z3: parameters that are given
% bl: block that is NOT restricted
%     bl=1-> MS structural parameters
%     bl=2-> Fixed structural parameters
%     bl=3-> sd structural errors
%     bl=4-> sd observation errors
%     bl=5-> Cov matrix transition matrix
%     bl=6-> Struct parameters transition matrix


EXTRA=[];

subvsp_ms=SUBV{1};subvsp_fc=SUBV{2};subvsp_fx=SUBV{3};
subvss_ms=SUBV{4};subvss_fc=SUBV{5};subvss_fx=SUBV{6};
subvse_ms=SUBV{7};subvse_fc=SUBV{8};subvse_fx=SUBV{9};
subvoe_ms=SUBV{10};subvoe_fc=SUBV{11};subvoe_fx=SUBV{12};

nsb=msel(10);
nsc=msel(11);

trH=msel(35);
if msel(26)==0
    p_st(subvsp_ms,:)=reshape(z1,size(subvsp_ms,1),nsb);
    for i=1:nsb
        p_st(subvsp_fc,i)=z2;
    end

    if size(subvsp_fx,1)>0
        for i=1:nsb
            p_st(subvsp_fx(:,1),i)=subvsp_fx(:,2);
        end
    end

   
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    p_ss(subvss_fc,:)=z3;
    if size(subvss_fx,1)>0
        p_ss(subvss_fx(:,1),1)=subvss_fx(:,2);
    end
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    if size(subvse_fc,1)==0
        p_er(subvse_ms,:)=reshape(z4,size(subvse_ms,1),nsc);
    else
        nscms=size(subvse_ms,1)*nsc;
        z4_ms=z4(1:nscms);
        z4_fc=z4(1+nscms:end);
        p_er(subvse_ms,:)=reshape(z4_ms,size(subvse_ms,1),nsc);
        for i=1:nsc
            p_er(subvse_fc,i)=z4_fc;
        end
    end
    if size(subvse_fx,1)>0
        for i=1:nsc
            p_er(subvse_fx(:,1),i)=subvse_fx(:,2);
        end
    end

    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    if size(subvoe_fc,1)>0
        o_er(subvoe_fc,:)=z5;
    end
    if size(subvoe_fx,1)>0
        o_er(subvoe_fx(:,1),1)=subvoe_fx(:,2);
    end
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

    % 
    if nsb>1 && msel(25)~=-5
        HB=constH4(z7,trH,msel(8),nsb);
    else
        HB=1;
    end

    if msel(12)==0 
        if nsc>1
            HC=constH4(z6,trH,msel(9),nsc);
        else
            HC=1;
        end
        HBE=HB;
    elseif msel(12)==3
    
    end
end


% 






