%==========================================================================
% Replication codes for Bianchi-Nicolo' 
% "A Generalized Approach to Indeterminacy in Linear Rational Expectations Models"
% Quantitative Economics
%==========================================================================
function [lh,sp,li,pr,MAT,prdet,lidet,flag]=blocks_ftpl7(z1,yt,z2,z3,z4,z5,z6,z7,bl,prsum,msel,TRSPEC,SUBV)
flag=[];
% z1: parameters that are free to move
% z2 & z3: parameters that are given
% bl: block that is NOT restricted
%     bl=1-> MS structural parameters
%     bl=2-> Fixed structural parameters
%     bl=3-> sd structural errors
%     bl=4-> sd observation errors
%     bl=5-> Cov matrix transition matrix
%     bl=6-> Struct parameters transition matrix


if bl==1
    abcd=[z1;z2;z3;z4;z5];
elseif bl==2
    abcd=[z2;z1;z3;z4;z5];
elseif bl==3
    abcd=[z2;z3;z1;z4;z5];
elseif bl==4
    abcd=[z2;z3;z4;z1;z5];
elseif bl==5
    abcd=[z2;z3;z4;z5;z1];
elseif bl==6
    abcd=[z2;z3;z4;z5;z6];
elseif bl==7
    abcd=[z2;z3;z4;z5;z6];
end

if size(TRSPEC,2)>=10
    lb=TRSPEC{10}(:,2);
    ub=TRSPEC{10}(:,3);
    ck1=any(abcd>ub) || any(abcd<lb);
else
    ck1=0;disp('No check in block_ftpl6')
end

if ck1==0

    if bl==1
        [p_st,p_ss,p_er,o_er,HB,HC,HBE,EXTRA]=bini_vpara_to_para6(z1,z2,z3,z4,z5,z6,z7,SUBV,msel);
    elseif bl==2
        [p_st,p_ss,p_er,o_er,HB,HC,HBE,EXTRA]=bini_vpara_to_para6(z2,z1,z3,z4,z5,z6,z7,SUBV,msel);
    elseif bl==3
        [p_st,p_ss,p_er,o_er,HB,HC,HBE,EXTRA]=bini_vpara_to_para6(z2,z3,z1,z4,z5,z6,z7,SUBV,msel);
    elseif bl==4
        [p_st,p_ss,p_er,o_er,HB,HC,HBE,EXTRA]=bini_vpara_to_para6(z2,z3,z4,z1,z5,z6,z7,SUBV,msel);
    elseif bl==5
        [p_st,p_ss,p_er,o_er,HB,HC,HBE,EXTRA]=bini_vpara_to_para6(z2,z3,z4,z5,z1,z6,z7,SUBV,msel);
    elseif bl==6
        [p_st,p_ss,p_er,o_er,HB,HC,HBE,EXTRA]=bini_vpara_to_para6(z2,z3,z4,z5,z6,z1,z7,SUBV,msel);
    elseif bl==7
        [p_st,p_ss,p_er,o_er,HB,HC,HBE,EXTRA]=bini_vpara_to_para6(z2,z3,z4,z5,z6,z7,z1,SUBV,msel);
    end
    
    param{1}=p_st;
    param{2}=p_ss;
    param{3}=p_er;
    param{4}=o_er;
    param{5}=HBE;
    param{6}=abcd;
    param{7}=EXTRA;% 

    if bl==1 || bl==2 || bl==3 || bl==7
        msel(15)=1;
    else
        msel(15)=2;
    end

            [lh,sp,li,pr,MAT,prdet,lidet,flag]=bini_neglpost(param,yt,prsum,msel,TRSPEC,HC,HB,SUBV);

else
    lh=333*(10^7);
    sp=[];li=[];pr=[];MAT=[];prdet=[];lidet=[];
    flag=2; 
end



