%==========================================================================
% Replication codes for Bianchi-Nicolo' 
% "A Generalized Approach to Indeterminacy in Linear Rational Expectations Models"
% Quantitative Economics
%==========================================================================
function [lh,sp,li,pr,MAT,prdet,lidet,flag]=blocks_ftpl7_all2(zz1,yt,abc,ind1,extr,PRSUM,msel,TRSPEC,SUBV,bl2)

% z1: parameters that are free to move
% z2 & z3: parameters that are given
% bl: block that is NOT restricted
%     bl=1-> MS structural parameters
%     bl=2-> Fixed structural parameters
%     bl=3-> sd structural errors
%     bl=4-> sd observation errors
%     bl=5-> Cov matrix transition matrix
%     bl=6-> Struct parameters transition matrix



abc(ind1)=zz1;

z1=abc(extr{1});
z2=abc(extr{2});
z3=abc(extr{3});
z4=abc(extr{4});
z5=abc(extr{5});
z6=abc(extr{6});
z7=abc(extr{7});
% [z1,z2,z3,z4,z5,z6,z7]=from_abc_to_max(abc,extr);
    
if bl2==1
    [lh,sp,li,pr,MAT,prdet,lidet,flag]=blocks_ftpl7(z1,yt,z2,z3,z4,z5,z6,z7,1,PRSUM,msel,TRSPEC,SUBV);
elseif bl2==2
    [lh,sp,li,pr,MAT,prdet,lidet,flag]=blocks_ftpl7(z4,yt,z1,z2,z3,z5,z6,z7,4,PRSUM,msel,TRSPEC,SUBV);   
end