%==========================================================================
% Replication codes for Bianchi-Nicolo' 
% "A Generalized Approach to Indeterminacy in Linear Rational Expectations Models"
% Quantitative Economics
%==========================================================================
function [BOU]=trspec_to_bou2(TRSPEC,SUBV,msel)
% z1: parameters that are free to move
% z2 & z3: parameters that are given
% bl: block that is NOT restricted
%     bl=1-> MS structural parameters
%     bl=2-> Fixed structural parameters
%     bl=3-> sd structural errors
%     bl=4-> sd observation errors
%     bl=5-> Cov matrix transition matrix
%     bl=6-> Struct parameters transition matrix




subvsp_ms=SUBV{1};subvsp_fc=SUBV{2};subvsp_fx=SUBV{3};
subvss_ms=SUBV{4};subvss_fc=SUBV{5};subvss_fx=SUBV{6};
subvse_ms=SUBV{7};subvse_fc=SUBV{8};subvse_fx=SUBV{9};
subvoe_ms=SUBV{10};subvoe_fc=SUBV{11};subvoe_fx=SUBV{12};

nsb=msel(10);
nsc=msel(11);

BOU{1}=repmat(TRSPEC{1}(subvsp_ms,2:3),nsb,1);
BOU{2}=TRSPEC{1}(subvsp_fc,2:3);
BOU{3}=TRSPEC{2}(subvss_fc,2:3);
BOU{4}=repmat(TRSPEC{3}(subvse_ms,2:3),nsc,1);
BOU{5}=TRSPEC{4}(subvoe_fc,2:3);